#include <stdint.h>

typedef void            (*T_gpio_setFp)                 (uint8_t);
typedef uint8_t         (*T_gpio_getFp)                 ();

typedef void            (*T_spi_writeFp)                (unsigned int);
typedef unsigned int    (*T_spi_readFp)                 (unsigned int);

typedef struct
{
        T_gpio_setFp        gpioSet[ 12 ];
        T_gpio_getFp        gpioGet[ 12 ];

}T_gpio_obj;

typedef struct
{
        T_spi_writeFp       spiWrite;
        T_spi_readFp        spiRead;

}T_spi_obj;

static void _mp3_setRST( uint8_t value )
{
    PTA_PDOR.B16 = value;
}

static void _mp3_setCS( uint8_t value )
{
    PTA_PDOR.B14 = value;
}

static void _mp3_setINT( uint8_t value )
{
    PTA_PDOR.B17 = value;
}

static uint8_t _mp3_getAN()
{
    return PTA_PDIR.B15;
}

static const T_gpio_obj _MP3_GPIO_OBJ =
{
    {
        0, _mp3_setRST, _mp3_setCS, 0, 0, 0,
        0, _mp3_setINT, 0, 0, 0, 0
    },
    {
        _mp3_getAN, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0
    }
};

static const T_spi_obj _MP3_SPI_OBJ =
{
    SPI0_Write,
    SPI0_Read
};

static void _mp3_boardInit()
{
    GPIO_Digital_Input(&PTA_PDIR, _GPIO_PINMASK_15 );
    GPIO_Digital_Output(&PTA_PDOR, _GPIO_PINMASK_17 );
    GPIO_Digital_Output(&PTA_PDOR, _GPIO_PINMASK_14 );
    GPIO_Digital_Output(&PTA_PDOR, _GPIO_PINMASK_16 );
}